require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_MACHINE_PROM_H_)) {
    eval 'sub _MACHINE_PROM_H_ () {1;}' unless defined(&_MACHINE_PROM_H_);
    eval 'sub MVMEPROM_INCHR () {0x;}' unless defined(&MVMEPROM_INCHR);
    eval 'sub MVMEPROM_INSTAT () {0x1;}' unless defined(&MVMEPROM_INSTAT);
    eval 'sub MVMEPROM_INLN () {0x2;}' unless defined(&MVMEPROM_INLN);
    eval 'sub MVMEPROM_READSTR () {0x3;}' unless defined(&MVMEPROM_READSTR);
    eval 'sub MVMEPROM_READLN () {0x4;}' unless defined(&MVMEPROM_READLN);
    eval 'sub MVMEPROM_OUTCHR () {0x20;}' unless defined(&MVMEPROM_OUTCHR);
    eval 'sub MVMEPROM_OUTSTR () {0x21;}' unless defined(&MVMEPROM_OUTSTR);
    eval 'sub MVMEPROM_DSKRD () {0x10;}' unless defined(&MVMEPROM_DSKRD);
    eval 'sub MVMEPROM_DSKWR () {0x11;}' unless defined(&MVMEPROM_DSKWR);
    eval 'sub MVMEPROM_DSKCFIG () {0x12;}' unless defined(&MVMEPROM_DSKCFIG);
    eval 'sub MVMEPROM_DSKFMT () {0x14;}' unless defined(&MVMEPROM_DSKFMT);
    eval 'sub MVMEPROM_DSKCTRL () {0x15;}' unless defined(&MVMEPROM_DSKCTRL);
    eval 'sub MVMEPROM_NETCTRL () {0x1d;}' unless defined(&MVMEPROM_NETCTRL);
    eval 'sub MVMEPROM_OUTSTRCRLF () {0x22;}' unless defined(&MVMEPROM_OUTSTRCRLF);
    eval 'sub MVMEPROM_WRITE () {0x23;}' unless defined(&MVMEPROM_WRITE);
    eval 'sub MVMEPROM_WRITELN () {0x24;}' unless defined(&MVMEPROM_WRITELN);
    eval 'sub MVMEPROM_DELAY () {0x43;}' unless defined(&MVMEPROM_DELAY);
    eval 'sub MVMEPROM_RTC_RD () {0x53;}' unless defined(&MVMEPROM_RTC_RD);
    eval 'sub MVMEPROM_EXIT () {0x63;}' unless defined(&MVMEPROM_EXIT);
    eval 'sub MVMEPROM_GETBRDID () {0x70;}' unless defined(&MVMEPROM_GETBRDID);
    eval 'sub MVMEPROM_ENVIRON () {0x71;}' unless defined(&MVMEPROM_ENVIRON);
    eval 'sub NETCTRLCMD_GETETHER () {1;}' unless defined(&NETCTRLCMD_GETETHER);
    eval 'sub ENVIRONCMD_WRITE () {1;}' unless defined(&ENVIRONCMD_WRITE);
    eval 'sub ENVIRONCMD_READ () {2;}' unless defined(&ENVIRONCMD_READ);
    eval 'sub ENVIRONTYPE_EOL () {0;}' unless defined(&ENVIRONTYPE_EOL);
    eval 'sub ENVIRONTYPE_START () {1;}' unless defined(&ENVIRONTYPE_START);
    eval 'sub ENVIRONTYPE_DISKBOOT () {2;}' unless defined(&ENVIRONTYPE_DISKBOOT);
    eval 'sub ENVIRONTYPE_ROMBOOT () {3;}' unless defined(&ENVIRONTYPE_ROMBOOT);
    eval 'sub ENVIRONTYPE_NETBOOT () {4;}' unless defined(&ENVIRONTYPE_NETBOOT);
    eval 'sub ENVIRONTYPE_MEMSIZE () {5;}' unless defined(&ENVIRONTYPE_MEMSIZE);
    unless(defined(&_LOCORE)) {
	eval 'sub BUG_FILE_MARK () {0x80;}' unless defined(&BUG_FILE_MARK);
	eval 'sub IGNORE_FILENUM () {0x2;}' unless defined(&IGNORE_FILENUM);
	eval 'sub END_OF_FILE () {0x1;}' unless defined(&END_OF_FILE);
	eval 'sub MVMEPROM_BLOCK_SIZE () {256;}' unless defined(&MVMEPROM_BLOCK_SIZE);
    }
    eval 'sub MVMEPROM_CALL {
        local($x) = @_;
	    eval q( &__asm__  &__volatile__ ( &__CONCAT(\\"trap #15; .short \\",  &__STRING($x)) ));
    }' unless defined(&MVMEPROM_CALL);
    eval 'sub MVMEPROM_NOARG () {
        eval q( &__asm__  &__volatile__ (\\"clrl sp@-\\"));
    }' unless defined(&MVMEPROM_NOARG);
    eval 'sub MVMEPROM_ARG1 {
        local($arg) = @_;
	    eval q( &__asm__  &__volatile__ (\\"movel %0, sp@-\\"::\\"d\\" ($arg)));
    }' unless defined(&MVMEPROM_ARG1);
    eval 'sub MVMEPROM_ARG2 {
        local($arg) = @_;
	    eval q( &__asm__  &__volatile__ (\\"movel %0, sp@-\\"::\\"d\\" ($arg)));
    }' unless defined(&MVMEPROM_ARG2);
    eval 'sub MVMEPROM_GETRES {
        local($ret) = @_;
	    eval q( &__asm__  &__volatile__ (\\"movel sp@+,%0\\": \\"=d\\" ($ret):));
    }' unless defined(&MVMEPROM_GETRES);
    eval 'sub MVMEPROM_RETURN {
        local($ret) = @_;
	    eval q( &MVMEPROM_GETRES($ret);  &return ($ret););
    }' unless defined(&MVMEPROM_RETURN);
    eval 'sub MVMEPROM_RETURN_BYTE {
        local($ret) = @_;
	    eval q( &MVMEPROM_GETRES($ret);  &return(($ret >> 24) & 0xff););
    }' unless defined(&MVMEPROM_RETURN_BYTE);
    eval 'sub MVMEPROM_STATRET {
        local($ret) = @_;
	    eval q( &MVMEPROM_GETRES($ret);  &return (!($ret & 0x4)););
    }' unless defined(&MVMEPROM_STATRET);
    eval 'sub MVMEPROM_REG_DEVLUN () {"d0";}' unless defined(&MVMEPROM_REG_DEVLUN);
    eval 'sub MVMEPROM_REG_CTRLLUN () {"d1";}' unless defined(&MVMEPROM_REG_CTRLLUN);
    eval 'sub MVMEPROM_REG_FLAGS () {"d4";}' unless defined(&MVMEPROM_REG_FLAGS);
    eval 'sub MVMEPROM_REG_CTRLADDR () {"a0";}' unless defined(&MVMEPROM_REG_CTRLADDR);
    eval 'sub MVMEPROM_REG_ENTRY () {"a1";}' unless defined(&MVMEPROM_REG_ENTRY);
    eval 'sub MVMEPROM_REG_CONFBLK () {"a2";}' unless defined(&MVMEPROM_REG_CONFBLK);
    eval 'sub MVMEPROM_REG_NBARGSTART () {"a3";}' unless defined(&MVMEPROM_REG_NBARGSTART);
    eval 'sub MVMEPROM_REG_NBARGEND () {"a4";}' unless defined(&MVMEPROM_REG_NBARGEND);
    eval 'sub MVMEPROM_REG_ARGSTART () {"a5";}' unless defined(&MVMEPROM_REG_ARGSTART);
    eval 'sub MVMEPROM_REG_ARGEND () {"a6";}' unless defined(&MVMEPROM_REG_ARGEND);
    unless(defined(&RB_NOSYM)) {
	eval 'sub RB_NOSYM () {0x4000;}' unless defined(&RB_NOSYM);
    }
}
1;
